; #####################################
; #         Lionel d'Hauenens         #
; # -= http://www.labo-asso.com/ =- #
; #####################################

; --------
; - MASM -
; --------

.686P
.model flat, stdcall
option casemap:none

    include \masm32\include\windows.inc
    include \masm32\include\user32.inc
    include \masm32\include\kernel32.inc
    includelib \masm32\lib\user32.lib
    includelib \masm32\lib\kernel32.lib

ASSUME fs:nothing

ThreadAffinityMask  equ 4
NumberOfProcessors  equ 064h
_pushad             equ 020h
_eax                equ 01Ch
saut                equ <0Dh,0Ah>

descriptor STRUCT
    _size    dw ?
    base     dd ?
descriptor ENDS

.data
;  ---------------------------------------------------
db "Lionel d'Hauenens - LABO Asso - 26/02/2006"
;  ---------------------------------------------------

    handle_mem_alloc    dd          0
    affinity_original   dd          0          
    table_idt_info      descriptor  20h dup(<0>)    ;\ Windows NT peut grer 
    table_gdt_info      descriptor  20h dup(<0>)    ;/ jusqu' 32 processeurs
    buf_descriptor      descriptor  <0>     

    titre db "LABO Asso - Info IDT/GDT :)",0

    texte_info_cpu  db "CPU 0x"
    num_cpu         db 2 dup(020h)
                    db saut,saut
                    db "--> Base IDT : 0x"
    base_idt        db 8 dup(020h)
                    db "    Size IDT : 0x"
    size_idt        db 4 dup(020h)
                    db saut 
                    db "--> Base GDT : 0x" 
    base_gdt        db 8 dup(020h)
                    db "    Size GDT : 0x"
    size_gdt        db 4 dup(020h)
                    db saut 
                    db saut
    size_texte_info_cpu equ ($-texte_info_cpu)
    
; ****************************************************************
; * Cette petite routine rcolte les infos sur les tables IDT et *
; * GDT de chaque processeur.                                    *                           
; ****************************************************************

.code
start:
    mov eax, fs:[030h]                              ; PEB
    mov ecx, dword ptr [eax+NumberOfProcessors]     ; PEB.NumberOfProcessors
    xor ebp , ebp               
    inc ebp                                         ; Mask
    mov edi, offset table_idt_info
    mov esi, offset table_gdt_info
    
Boucle_CPU :
    push ecx
    
    push ebp            ; Mask   
    push 0FFFFFFFEh     ; Handle Current Thread
    call SetThreadAffinityMask
    or eax,eax
    je erreur
    cmp ebp, 01
    jne @F
    mov dword ptr [affinity_original], eax
@@ :    
    sidt buf_descriptor
    mov ax, word ptr [buf_descriptor._size]
    mov word ptr [edi], ax
    mov eax, dword ptr [buf_descriptor.base]
    mov dword ptr [edi+2], eax

    sgdt buf_descriptor
    mov ax, word ptr [buf_descriptor._size]
    mov word ptr [esi], ax
    mov eax, dword ptr [buf_descriptor.base]
    mov dword ptr [esi+2], eax

    add edi, SIZEOF descriptor
    add esi, SIZEOF descriptor
        
    shl ebp, 1          ; place le mask sur le cpu suivant
    pop ecx
    loop Boucle_CPU  
    
; ---------------------
; - Restore Affinity -
; ---------------------
    push dword ptr [affinity_original]  ; Mask   
    push 0FFFFFFFEh                     ; Handle Current Thread
    call SetThreadAffinityMask 

; ---------------------------------------------
; - Affichage du rsultat dans une messagebox -
; ---------------------------------------------

    call affiche_resultat

; ---------------------
; -      Sortie       -
; ---------------------

sortie :
    push 0
    call [ExitProcess]

; ---------------------
; - Message d'erreur  -
; ---------------------

erreur :
    push 010h
    call @F
    db "Erreur !",0
@@ :
    call @F
    db "Impossible de manipuler l'Affinity du thread :(",0
@@ :
    push 0
    call MessageBoxA
    jmp sortie    

; ---------------------------------------------
; - Affichage du rsultat dans une messagebox -
; ---------------------------------------------

affiche_resultat :

    pushad

    push PAGE_READWRITE
    push MEM_COMMIT
    push 1000h
    push 0
    call VirtualAlloc
    mov dword ptr [handle_mem_alloc], eax
    mov edi, eax   

    lea ebx, offset table_idt_info
    lea edx, offset table_gdt_info

    xor ebp,ebp
    cld
boucle_affiche_resultat :

    push 2               
    push offset num_cpu 
    push ebp                   
    call hex2ascii 

    push 8                     
    push offset base_idt       
    push dword ptr [ebx].descriptor.base                    
    call hex2ascii 

    movzx eax, word ptr [ebx].descriptor._size
    push 4                     
    push offset size_idt       
    push eax                      
    call hex2ascii  

    push 8                     
    push offset base_gdt       
    push dword ptr [edx].descriptor.base                    
    call hex2ascii

    movzx eax, word ptr [edx].descriptor._size
    push 4                     
    push offset size_gdt       
    push eax                      
    call hex2ascii

    mov esi, offset texte_info_cpu
    mov ecx, size_texte_info_cpu
    rep movsb   

    add ebx, SIZEOF descriptor
    add edx, SIZEOF descriptor
    inc ebp
    
    mov eax, fs:[030h]                              ; PEB
    cmp ebp, dword ptr [eax+NumberOfProcessors]     ; PEB.NumberOfProcessors
    jb boucle_affiche_resultat

    xor eax,eax
    stosb

    push 010h
    push offset titre
    push dword ptr [handle_mem_alloc]
    push 0
    call MessageBoxA

    push MEM_RELEASE
    push 0
    push dword ptr [handle_mem_alloc]
    call VirtualFree

    popad
    ret

;**************************************************************
;*  Convertir une valeur hexadecimal en chaine de caractres. *
;*                                                            *
;*  Nombre de carcatres: 1-8                                 *
;*                                                            *
;* Entre : push valeur dd -> nb de caract  crire           *
;*          push pointeur  -> pointeur du buffer caract       *
;*          push valeur dd -> valeur hex (32bits)             *
;*          call hex2ascii                                    *
;*                                                            *
;* Sortie : eax=1 : bon / eax=0 : erreur                      *
;**************************************************************

hex2ascii :
        pushfd
        pushad
        
        mov       edx,[esp+028h+(0*4)] ; -> valeur hex (32bits)
        mov       edi,[esp+028h+(1*4)] ; -> pointeur du buffer caract.
        mov       ecx,[esp+028h+(2*4)] ; -> nb de caractere  convertir
        cmp ecx,8
        ja retour_erreur_hex2ascii

        std 
        lea       edi, dword ptr [edi+ecx-1]
boucle_hex2ascii :
        mov       al,dl
        and       al,0Fh 
        add       al,30h 
        cmp       al,39h 
        jbe       @F  
        add       al,07 
@@:
        stosb
        shr       edx,04
        loop      boucle_hex2ascii 
        
        xor eax,eax
        inc eax         ; good :)
        
sortie_hex2ascii :
        mov dword ptr [esp+_eax], eax
        popad
        popfd
        retn (3*4)        
        
retour_erreur_hex2ascii :
        xor eax,eax     ; ae !
        jmp sortie_hex2ascii

end start


